unit ProchazeniF;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, jpeg, Grids, math, ExtCtrls;

type
  TForm1 = class(TForm)
    DirectoryListBox1: TDirectoryListBox;
    DrawGrid1: TDrawGrid;
    Timer1: TTimer;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormResize(Sender: TObject);
    procedure DrawGrid1DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure DrawGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    procedure ResetGrid;
  end;

  TObrazek=class    //Tda jednoho obrzku
    name:string;
    vel:Integer;
    dir:string;
    img:TJPEGImage;
    thmb:TBitmap;
    time:TDateTime;
    loaded:boolean;
    constructor create(imgdir:string;rect:TSearchRec);
    procedure Load;
  end;

  TLoadingThread=class(TThread)     // Vlkno kter postupn nat obrzky
   protected
      procedure Execute; override;
  end;

var
  Form1: TForm1;
  t:TLoadingThread;
  Obrazky:Tlist;
  iloaded:integer;
  chyba:boolean;

implementation

uses ZobrazeniF;
{$R *.dfm}

procedure TLoadingThread.Execute;
var i:integer;
begin
 for i  := 0 to (Obrazky.Count - 1) do
   begin
     TObrazek(Obrazky.Items[i]).Load;
   end;
end;

procedure TObrazek.Load;
var r:TRect;
begin
 if loaded then exit;
 img:=TJPEGImage.Create;
 try
 img.LoadFromFile(name);
 except on exception do
 begin
  loaded:=true;
  chyba:=true;
 end;
 end;
 thmb:=TBitmap.Create;
 thmb.Width:=100;
 thmb.Height:=100;
 r.Left:=0;
 r.Right:=100;
 r.Bottom:=100;
 r.Top:=0;
 thmb.Canvas.StretchDraw(r,img);      // Miniatura
 loaded:=true;
 inc(iloaded);
end;

constructor TObrazek.create(imgdir:string;rect:TSearchRec);
begin
 dir:=imgdir;
 name:=rect.Name;
 vel:=rect.Size;
 time:=FileDateToDateTime(rect.Time);
end;


procedure TForm1.DirectoryListBox1Change(Sender: TObject);
var Rect:TSearchRec;
begin
 if t<>nil then
 begin
  chyba:=false;
  t.Free;
  chyba:=false;
 end;

 Obrazky.Clear;
 iLoaded:=0;                     // Projde cel adres
 if
  FindFirst(DirectoryListBox1.Directory+'/*.jpg',faAnyFile,Rect)=0 then
   begin
     Obrazky.Add(TObrazek.create(DirectoryListBox1.Directory,Rect));
     while FindNext(Rect)=0 do
     begin
      Obrazky.Add(TObrazek.create(DirectoryListBox1.Directory,Rect));
     end;
     FindClose(Rect);
   end;
 ResetGrid;                          // Penastav tabulku
 t:= TLoadingThread.Create(true);
 t.Priority:=tpLower;
 t.Resume;

end;

procedure TForm1.DrawGrid1DblClick(Sender: TObject);
var p:integer;
begin
 p:=DrawGrid1.Selection.Left+DrawGrid1.Selection.top*DrawGrid1.ColCount;
 if Obrazky.Count<=p then exit;
 ImgIndex:=p;
 Hide;                               //Pepnut na reim zobrazen
 Form2.Show;
end;

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var p:integer;
    o:TObrazek;
begin                          // vykresl buku tabulky s miniaturou
 p:=ACol+ARow*DrawGrid1.ColCount;
 if Obrazky.Count>p then
  o:=TObrazek(Obrazky.Items[p])
 else exit;

if o.loaded then
begin
  DrawGrid1.Canvas.Brush.Style:=bsClear;
  DrawGrid1.Canvas.Draw(Rect.Left+5,Rect.Top+5,o.thmb);
  DrawGrid1.Canvas.TextOut(Rect.Left+5,Rect.Bottom-50,o.name);

  DrawGrid1.Canvas.TextOut(Rect.Left+5,Rect.Bottom-35,Inttostr(o.vel)+'bajtu');
  DrawGrid1.Canvas.TextOut(Rect.Left+5,Rect.Bottom-25,DateTimeToStr(o.time));

  DrawGrid1.Canvas.TextOut(Rect.Left+5,Rect.Bottom-15,Inttostr(o.img.Width)+'x'+Inttostr(o.img.Height));
 end else
begin
  DrawGrid1.Canvas.TextOut(Rect.Left+5,Rect.Top+5,'Nahrava se ...');
end;

end;

procedure TForm1.DrawGrid1KeyPress(Sender: TObject; var Key: Char);
begin
 DrawGrid1DblClick(self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Obrazky:=TList.Create;

  if ParamCount>0 then          // Zkontrolovan jestli neni sloka v parametru
  begin
   if DirectoryExists(ParamStr(1)) then
    DirectoryListBox1.Directory:=ParamStr(1) else
   if FileExists(ParamStr(1)) then
    DirectoryListBox1.Directory:=ExtractFileDir(ParamStr(1));
   DirectoryListBox1Change(self);
  end;

end;

procedure TForm1.FormResize(Sender: TObject);
begin                // Penastaven potu sloupc v tabulce
 DrawGrid1.ColCount:=(DrawGrid1.Width-20) div DrawGrid1.DefaultColWidth;
end;

procedure TForm1.ResetGrid;
begin
 drawGrid1.RowCount:=Obrazky.Count div DrawGrid1.ColCount;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if iLoaded<Obrazky.cOunt then
 DrawGrid1.Repaint;

 if chyba then
 begin
   chyba:=false;
   ShowMessage('Pi natn obrzku dolo k chyb... program nemus dle pracovat sprvn.');
 end;
end;

end.
