unit ZobrazeniF;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,math, ExtCtrls, grids;

type
  TForm2 = class(TForm)
    Timer1: TTimer;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    Zoom:real;
    procedure DrawImg;
    procedure CheckImg;
    procedure HConvert;
    procedure VConvert;
    procedure Lotoc;
    procedure Rotoc;
    procedure BestView;
  end;

var
  Form2: TForm2;
  ImgIndex:integer;
  AppPath:string;

implementation

uses ProchazeniF;

{$R *.dfm}

procedure TForm2.BestView;          // Nejlepsi zoom


var     o:TObrazek;
        r1,r2:real;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 r1:= Screen.Width/o.img.Width;
 r2:= Screen.Height/o.img.Height;
 Zoom:=min(r1,r2);
end;

procedure TForm2.Lotoc;          // Otocit do leva
var     o:TObrazek;
        x,y:integer;
        bmp1,bmp2:TBitmap;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 bmp1:=TBitmap.Create;
 bmp1.Assign(o.img);
 bmp2:=TBitmap.Create;
 bmp2.Width:=bmp1.Height;
 bmp2.Height:=bmp1.Width;

for x := 0 to bmp1.Width -1 do
  for y := 0 to bmp1.Height  do
   begin
    bmp2.Canvas.Pixels[y,bmp2.Height-x-1]:=bmp1.Canvas.Pixels[x,y];
   end;

o.img.Assign(bmp2);
bmp1.Destroy;
bmp2.Destroy;
end;

procedure TForm2.Rotoc;        // Otocit do prava
var     o:TObrazek;
        x,y:integer;
        bmp1,bmp2:TBitmap;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 bmp1:=TBitmap.Create;
 bmp1.Assign(o.img);
 bmp2:=TBitmap.Create;
 bmp2.Width:=bmp1.Height;
 bmp2.Height:=bmp1.Width;

for x := 0 to bmp1.Width -1 do
  for y := 0 to bmp1.Height  do
   begin
    bmp2.Canvas.Pixels[bmp2.Width-y-1,x]:=bmp1.Canvas.Pixels[x,y];
   end;

o.img.Assign(bmp2);
bmp1.Destroy;
bmp2.Destroy;
end;



procedure TForm2.HConvert;       // Horizonatln peklopen
var     o:TObrazek;
        x,y:integer;
        c:TColor;
        bmp:TBitmap;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 bmp:=TBitmap.Create;
 bmp.Assign(o.img);
for x := 0 to o.img.Width -1 do
  for y := 0 to o.img.Height div 2 do
   begin
    c:=bmp.Canvas.Pixels[x,y];
    bmp.Canvas.Pixels[x,y]:=bmp.Canvas.Pixels[x,o.img.Height-y];
    bmp.Canvas.Pixels[x,o.img.Height-y]:=c;
   end;
o.img.Assign(bmp);
bmp.Destroy;

end;

procedure TForm2.Timer1Timer(Sender: TObject);     // SlideShow
begin
    ImgIndex:=ImgIndex+1;
    if ImgIndex>Obrazky.Count-1 then ImgIndex:=0;
    CheckImg;
    Repaint;
end;

procedure TForm2.VConvert;      // Vertikln peklopen
var     o:TObrazek;
        x,y:integer;
        c:TColor;
        bmp:TBitmap;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 bmp:=TBitmap.Create;
 bmp.Assign(o.img);
for x := 0 to o.img.Width div 2 do
  for y := 0 to o.img.Height-1 do
   begin
    c:=bmp.Canvas.Pixels[x,y];
    bmp.Canvas.Pixels[x,y]:=bmp.Canvas.Pixels[o.img.Width-x,y];
    bmp.Canvas.Pixels[o.img.Width-x,y]:=c;
   end;
o.img.Assign(bmp);
bmp.Destroy;

end;

procedure TForm2.DrawImg;      // Vykreslen obrzku na canvas s mtkems
var r:TRect;
    w,h:real;
    o:TObrazek;
    s:TGridRect;
begin
  s.Top:=ImgIndex div Form1.DrawGrid1.ColCount;
  s.Left:=ImgIndex-s.Top*Form1.DrawGrid1.ColCount;
  s.Bottom:=s.Top;
  s.Right:=s.Left;
  Form1.DrawGrid1.Selection:=s;

 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 w:= o.img.Width * Zoom;             // Zoom
 h:= o.img.Height * Zoom;

 r.Left:=round(Screen.Width/2 - w/2);
 r.Right:=round(Screen.Width/2 + w/2);

 r.Top:=round(Screen.Height/2 - h/2);
 r.Bottom:=round(Screen.Height/2 + h/2);

 Canvas.StretchDraw(r,o.img);

end;

procedure TForm2.FormCreate(Sender: TObject);
begin
 DoubleBuffered:=true;
 AppPath:=GetCurrentDir;
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var     o:TObrazek;
begin
case key of
13:                     // Enter
   begin
    Close;
    Form1.Show;
  end;

33:                           //PageUp
  begin
    ImgIndex:=ImgIndex-1;
    if ImgIndex<0 then ImgIndex:=Obrazky.Count-1;
    CheckImg;
         BestView;
    Repaint;
  end;
34:                          //PageDown
  begin
    ImgIndex:=ImgIndex+1;
    if ImgIndex>Obrazky.Count-1 then ImgIndex:=0;
    CheckImg;
         BestView;
    Repaint;
  end;
35:                          // ENd
  begin
    ImgIndex:=Obrazky.Count-1;
    CheckImg;
         BestView;
    Repaint;
  end;

36:                          //Home
  begin
    ImgIndex:=0;
    CheckImg;
         BestView;
    Repaint;
  end;
107:                        // PLus
  begin
    Zoom:=Zoom*1.05;
    Repaint;
  end;
109:                         //Minus
  begin
    Zoom:=Zoom*0.95;
    Repaint;
  end;
106:                     // Lomitko
 begin
    Zoom:=1;
    Repaint;
 end;
111:
 begin
     BestView;
      Repaint;
 end;
71:                            // g
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);
 o.img.Grayscale:= not o.img.Grayscale;
    Repaint;
end;

72:                      // h
begin
     HConvert;
    Repaint;
end;
96:                          // v
begin
    VConvert;
    Repaint;
end;


end;


end;



procedure TForm2.FormKeyPress(Sender: TObject; var Key: Char);
var
  I: Integer;
  o:TObrazek;
  s:TStringList;
begin
 if Key='s' then          //s
 begin
  Timer1.Enabled:=true;
 end;

 if Key='l' then            // Otoceni do leva
 begin
   LOtoc;
   Repaint;
 end;

 if Key='r' then             //Otoceni do prava
 begin
   ROtoc;
   Repaint;
 end;

 if ORD(Key)=27 then             // Esc
 begin
  if Timer1.Enabled then
   begin
    Timer1.Enabled:=False;
    Repaint;
    end else

    Application.Terminate;
 end;

 if Key='e' then                //e export do html
 begin
   s:=TStringList.Create;
   s.Add('<html>');


   if not DirectoryExists(AppPath+'\Export') then
   CreateDirectory(PCHAR(AppPath+'\Export'),0);
   if not DirectoryExists(AppPath+'\Export\Images') then
   CreateDirectory(PCHAR(AppPath+'\Export\Images'),0);
   if not DirectoryExists(AppPath+'\Export\Thumbs') then
   CreateDirectory(PCHAR(AppPath+'\Export\Thumbs'),0);
   for I := 0 to (Obrazky.Count - 1) do
   begin
     o:=  TObrazek(Obrazky.Items[i]);
     if o=nil then break;
     if not o.loaded then o.load;
     
     if o.img.Empty=false then
     o.img.SaveToFile(AppPath+'\Export\Images\'+o.name);
     if o.img.Empty=false then
     o.thmb.SaveToFile(AppPath+'\Export\Thumbs\'+StringReplace(o.name,'.jpg','.bmp',[rfReplaceAll]));

     s.Add('<a href=Images/'+o.name+' target=blank>');
     s.Add('<img src=Thumbs/'+StringReplace(o.name,'.jpg','.bmp',[rfReplaceAll])+'>');
     s.Add('</a>');

     Sleep(0);
   end;


  s.Add('</html>');
  s.SaveToFile(AppPath+'\Export\export.html');
  ShowMessage('Ulozeno do '+AppPath+'\Export\export.html');

 
 end;

  
end;

procedure TForm2.CheckImg;
var     o:TObrazek;
var r1,r2:real;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 if o.loaded=false then
    o.load;
end;

procedure TForm2.FormPaint(Sender: TObject);
var     o:TObrazek;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 Canvas.Brush.Color:=clWhite;
 Canvas.Rectangle(ClientRect);
 DrawImg;

   Canvas.Font.Color:=clBlack;

  Canvas.Brush.Style:=bsClear;              // Informace o obrazku
  Canvas.TextOut(10,10,'Nazev:'+o.name);
  Canvas.TextOut(10,25,'Rozliseni:'+Inttostr(o.img.Width)+'x'+Inttostr(o.img.Height));
  Canvas.TextOut(10,40,'velikost:'+Inttostr(o.vel)+'bajtu');
  Canvas.TextOut(10,55,'Zoom:'+FloatToStr(Zoom));
  Canvas.TextOut(10,70,'Datum:'+DateTimeToStr(o.time));
  Canvas.TextOut(10,85,'Obrzek:'+inttostr(ImgIndex+1)+'/'+inttostr(Obrazky.Count));

  Canvas.Font.Color:=clGreen;

  Canvas.TextOut(10,Screen.Height-135,'Pedchoz: PageUp');    // Npovda
  Canvas.TextOut(10,Screen.Height-125,'Dal: PageDowb');
  Canvas.TextOut(10,Screen.Height-115,'Zatek: Home');
  Canvas.TextOut(10,Screen.Height-105,'Konec: End');
  Canvas.TextOut(10,Screen.Height-95,'Zvten: Plus');
  Canvas.TextOut(10,Screen.Height-85,'Zmenen: Mnus');
  Canvas.TextOut(10,Screen.Height-75,'100%Zoom: *');
  Canvas.TextOut(10,Screen.Height-65,'Optimln Zoom: /');
  Canvas.TextOut(10,Screen.Height-55,'Pekliopen: h,v');
  Canvas.TextOut(10,Screen.Height-45,'Otoen: l,r');
  Canvas.TextOut(10,Screen.Height-35,'Eport do Html: e');
  Canvas.TextOut(10,Screen.Height-25,'SlideShow: s');
  Canvas.TextOut(10,Screen.Height-15,'ernoble: g');   

  if Timer1.Enabled then
  begin
  Canvas.TextOut(10,85,'SlideShow...');

  end;
end;

procedure TForm2.FormShow(Sender: TObject);
var r1,r2:real;
    o:TObrazek;
begin
 o:=  TObrazek(Obrazky.Items[ImgIndex]);

 BorderStyle:=bsNone;      // Nateven fullscreenu
 Left:=0;
 Width:=Screen.Width;
 Height:=Screen.Height;
 Top:=0;

 CheckImg;
 BestView;

 Repaint;
end;

end.
